routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
// App\User::create([
//     'name' => 'jegaest',
//     'email' => 'jegaest@juju.com',
//     'password' => bcrypt('test123'),
// ]);

// Listar sentencias sql en web
/*DB::listen(function($query){
    echo "<pre>{$query->sql}</pre>";
    //echo "<pre>{$query->time}</pre>";
});*/

Route::get('roles', function(){
    return \App\Role::with('user')->get();
});

Route::get('/', ['as' => 'home', 'uses' => 'PagesController@home']);
Route::get('/home', ['as' => 'home', 'uses' => 'PagesController@home']);

Route::get('saludos/{nombre?}', ['as' => 'saludos', 'uses' => 'PagesController@saludo'])->where('nombre', "[A-Za-z]+");

// Implementation for messages
Route::resource('mensajes', 'MessagesController');

// Implementation for users
Route::resource('usuarios', 'UsersController');

Route::get('login', 'Auth\LoginController@showLoginForm');
Route::post('login', 'Auth\LoginController@login')->name('login');
Route::get('logout', 'Auth\LoginController@logout');

app/Message.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Message extends Model
{
    protected $fillable = ['nombre', 'email', 'mensaje'];

    public function user()
    {
        return $this->belongsTo(User::class);
    }

    public function note()
    {
        return $this->morphOne(Note::class, 'notable');
    }

    public function tags()
    {
        return $this->morphToMany(Tag::class, 'taggable');
    }
}

app/Http/Controllers/MessagesController.php
<?php

namespace App\Http\Controllers;

use App\Message;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class MessagesController extends Controller
{
    public function __construct(){
        $this->middleware('auth', ['except' => ['create', 'store']]);
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $messages = Message::with(['user', 'note', 'tags'])->get();

        return view('messages.index', compact('messages'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('messages.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $message = Message::create($request->all());

        if (auth()->check()) {
            auth()->user()->messages()->save($message);
        }

        return redirect()->route('mensajes.create')->with('info', 'Hemos recibido tu mensaje');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $message = Message::findOrFail($id);

        return view('messages.show', compact('message'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $message = Message::findOrFail($id);

        return view('messages.edit', compact('message'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $message = Message::findOrFail($id);

        $message->update($request->all());

        return redirect()->route('mensajes.index');

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $message = Message::findOrFail($id)->delete();

        return redirect()->route('mensajes.index');
    }
}

resources/views/messages/create.blade.php
@extends('layout')

@section('contenido')
    <h1>Mensaje</h1>
    @if( session()->has('info'))
        <h3>{{ session('info') }}</h3>
    @else
    <form method="POST" action="{{route('mensajes.store')}}">
        @include('messages.form', ['message' => new App\Message, 'showFields' => auth()->guest()])
    </form>
    <hr>
    @endif
@stop

resources/views/messages/edit.blade.php
@extends('layout')

@section('contenido')
    <h1>Editar Mensaje</h1>
        <form method="POST" action="{{route('mensajes.update', $message->id)}}">
           {!! method_field('PUT') !!}
           @include('messages.form', ['btnText' => 'Actualizar', 'showFields' => !$message->user_id])
    </form>
    <hr>
@stop

resources/views/messages/form.blade.php
{!! csrf_field() !!}
@if ($showFields)
    <p>
        <label for="nombre">
            Nombre
            <input class="form-control" type="text" name="nombre" value="{{ $message->nombre or old('nombre') }}">
            {!! $errors->first('nombre', '<span class=error>:message</span>') !!}
        </label>
    </p>
    <p>
        <label for="email">
            Email
            <input class="form-control" type="email" name="email" value="{{ $message->email or old('email') }}">
            {!! $errors->first('email', '<span class=error>:message</span>') !!}
        </label>
    </p>
@endif
<p>
    <label for="mensaje">
        Mensaje
        <textarea class="form-control" name="mensaje">{{ $message->mensaje or old('mensaje') }}</textarea>
        {!! $errors->first('mensaje', '<span class=error>:message</span>') !!}
    </label>
</p>
<p><input class="btn btn-primary" type="submit" value="{{ $btnText or 'Guardar' }}"></p>

resources/views/messages/index.blade.php
@extends('layout')

@section('contenido')
    <h1>Todos los mensajes</h1>
    <table class="table">
        <thead>
            <th>ID</th>
            <th>Nombre</th>
            <th>Email</th>
            <th>Mensaje</th>
            <th>Notas</th>
            <th>Etiquetas</th>
            <th>Acciones</th>
        </thead>
        <tbody>
            @foreach ($messages as $message)
                <tr>
                    <td>{{ $message->id }}</td>
                    @if ($message->user_id)
                        <td>
                            <a href="{{ route('usuarios.show', $message->user_id) }}">
                                {{ $message->user->name }}
                            </a>
                        </td>
                        <td>{{ $message->user->email }}</td>
                    @else
                        <td>{{ $message->nombre }}</td>
                        <td>{{ $message->email }}</td>
                    @endif
                    <td><a href="{{ route('mensajes.show', $message->id) }}">{{ $message->mensaje }}</a></td>
                    <td>{{ $message->note ? $message->note->body : '' }}</td>
                    <td>{{ $message->tags->pluck('nombre')->implode(', ') }}</td>
                    <td>
                        <a class="btn btn-info btn-xs" href="{{ route('mensajes.edit', $message->id) }}">Editar</a>
                        <form style="display: inline;" method="POST" action="{{route('mensajes.destroy', $message->id)}}">
                            {!! method_field('DELETE') !!}
                            {!! csrf_field() !!}
                            <button class="btn btn-danger btn-xs" type="submit">Eliminar</button>
                        </form>
                    </td>
                </tr>
            @endforeach
        </tbody>
    </table>

@stop

resources/views/messages/show.blade.php
@extends('layout')

@section('contenido')
    <h1>Mensaje</h1>
    <p>Enviado por {{ $message->nombre }} - {{ $message->email }}</p>
    <p>{{ $message->mensaje }}</p>

@stop